var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Immutable = require('immutable');
exports.AclRecordCtor = Immutable.Record;
function parseAclRecord(value, deps) {
    var recordWalker = function (value, key) {
        switch (true) {
            default: return fromJSDefault(value);
        }
    };
    var result = {};
    for (var k in value) {
        if (value.hasOwnProperty) {
            result[k] = recordWalker(value[k], k);
        }
    }
    return new deps.AclRecord(result);
}
exports.parseAclRecord = parseAclRecord;
var AclRecord = (function (_super) {
    __extends(AclRecord, _super);
    function AclRecord() {
        _super.apply(this, arguments);
    }
    AclRecord.fromJS = function (value, deps) {
        return parseAclRecord(value, deps);
    };
    return AclRecord;
})(exports.AclRecordCtor({
    isAdmin: null,
    canEditArticles: null,
}));
exports.AclRecord = AclRecord;
exports.allRecords = {
    AclRecord: AclRecord,
};
function fromJSDefault(json) {
    if (Array.isArray(json)) {
        return Immutable.Seq.Indexed(json).map(fromJSDefault).toList();
    }
    if (isPlainObj(json)) {
        return Immutable.Seq.Keyed(json).map(fromJSDefault).toMap();
    }
    return json;
}
function isPlainObj(value) {
    return value && (value.constructor === Object || value.constructor === undefined);
}
//# sourceMappingURL=acl-i.js.map