var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Immutable = require('immutable');
var user_1 = require('./user');
exports.UserType = user_1.UserType;
exports.UserRecordCtor = Immutable.Record;
function parseUserRecord(value, deps) {
    var recordWalker = function (value, key) {
        switch (true) {
            case key == 'profile':
                return deps.ProfileRecord.fromJS(value, deps);
            case key == 'friends':
                return Immutable.List(value.map(function (item) {
                    return deps.UserRecord.fromJS(item, deps);
                }));
            case key == 'acl':
                return deps.AclRecord.fromJS(value, deps);
            default: return fromJSDefault(value);
        }
    };
    var result = {};
    for (var k in value) {
        if (value.hasOwnProperty) {
            result[k] = recordWalker(value[k], k);
        }
    }
    return new deps.UserRecord(result);
}
exports.parseUserRecord = parseUserRecord;
var UserRecord = (function (_super) {
    __extends(UserRecord, _super);
    function UserRecord() {
        _super.apply(this, arguments);
    }
    UserRecord.fromJS = function (value, deps) {
        return parseUserRecord(value, deps);
    };
    return UserRecord;
})(exports.UserRecordCtor({
    profile: null,
    login: null,
    friends: Immutable.List(),
    type: null,
    acl: null,
}));
exports.UserRecord = UserRecord;
exports.allRecords = {
    UserRecord: UserRecord,
};
function fromJSDefault(json) {
    if (Array.isArray(json)) {
        return Immutable.Seq.Indexed(json).map(fromJSDefault).toList();
    }
    if (isPlainObj(json)) {
        return Immutable.Seq.Keyed(json).map(fromJSDefault).toMap();
    }
    return json;
}
function isPlainObj(value) {
    return value && (value.constructor === Object || value.constructor === undefined);
}
//# sourceMappingURL=user-i.js.map